Last Comment Bug 590961 - [Mac] OOPP: Don't get crash reports from 32-bit plugins in 64-bit Firefox
: [Mac] OOPP: Don't get crash reports from 32-bit plugins in 64-bit Firefox
Status: VERIFIED FIXED
:
Product: Toolkit
Classification: Components
Component: Breakpad Integration (show other bugs)
: Trunk
: x86_64 Mac OS X
: -- critical with 1 vote (vote)
: mozilla2.0b9
Assigned To: Ted Mielczarek [:ted.mielczarek]
:
Mentors:
Depends on:
Blocks:
  Show dependency treegraph
 
Reported: 2010-08-26 10:27 PDT by Marcia Knous [:marcia - use ni]
Modified: 2010-12-19 06:32 PST (History)
17 users (show)
ted: in‑testsuite?
mozillamarcia.knous: in‑litmus?
See Also:
Crash Signature:
(edit)
QA Whiteboard:
Iteration: ---
Points: ---
Has Regression Range: ---
Has STR: ---
betaN+


Attachments
Screenshot of crash page (163.47 KB, image/png)
2010-08-26 10:27 PDT, Marcia Knous [:marcia - use ni]
no flags Details

Description Marcia Knous [:marcia - use ni] 2010-08-26 10:27:30 PDT
Created attachment 469509 [details]
Screenshot of crash page

Using Flash Version: 10.1.82.76 and Mozilla/5.0 (Macintosh; Intel Mac OS X 10.6; rv:2.0b5pre) Gecko/20100826 Minefield/4.0b5pre, I crashed but I got a "No Report Available." 

STR:
1. Crash while playing a hulu.com video. I might have "Popped Out" the video player before the crash.
2. Get the attached screenshot

Some stuff from the console:

8/26/10 9:51:49 AM	[0x0-0x1e01e].org.mozilla.firefox	Thu Aug 26 09:51:49 host-5-35.mv.mozilla.com firefox-bin[6582] <Error>: kCGErrorInvalidOperation: _CGSFindSharedWindow: WID 934
8/26/10 9:51:49 AM	[0x0-0x1e01e].org.mozilla.firefox	Thu Aug 26 09:51:49 host-5-35.mv.mozilla.com firefox-bin[6582] <Error>: kCGErrorFailure: Set a breakpoint @ CGErrorBreakpoint() to catch errors as they are logged.
8/26/10 9:51:49 AM	[0x0-0x1e01e].org.mozilla.firefox	Thu Aug 26 09:51:49 host-5-35.mv.mozilla.com firefox-bin[6582] <Error>: kCGErrorInvalidOperation: _CGSFindSharedWindow: WID 934
8/26/10 9:56:43 AM	plugin-container[6583]	Warning once: This application, or a library it uses, is using NSQuickDrawView, which has been deprecated. Apps should cease use of QuickDraw and move to Quartz.
Comment 1 Ted Mielczarek [:ted.mielczarek] 2010-08-27 05:29:14 PDT
If you can find STR I can investigate this.
Comment 2 Johnny Stenback (:jst, jst@mozilla.com) 2010-09-23 15:21:42 PDT
I don't think we want to ship Firefox 4 w/o reliable crash reporting for plugins, blocking.
Comment 3 Marcia Knous [:marcia - use ni] 2010-09-23 16:14:09 PDT
Unfortunately I haven't seen this since the initial report. But I test OOPP every day on the Mac so I will keep a watchful eye.
Comment 4 Ted Mielczarek [:ted.mielczarek] 2010-09-24 04:17:00 PDT
Without STR, I think it's very hard to block on this.
Comment 5 d.a. 2010-11-01 06:57:39 PDT
This bug says x86, but for me it only happens on x86-64 Firefox process. I can't recall ever having a crash report for Flash since firefox-bin became a i386/x86-64 binary.

Anyways:

While watching my YouTube subscriptions earlier today the plugin would crash without any report if I navigated to the next video (or any new page) while the video was still playing.

Running Firefox in 32-bit mode instead of the default 64-bit gave me this crash report doing the same thing:

http://crash-stats.mozilla.com/report/index/714134b6-296b-4b34-9632-9159e2101101
http://crash-stats.mozilla.com/report/index/5dc55a32-ba3b-4dd9-9d2a-f70fd2101101

Also happens when viewing a playlist, like this one:
http://www.youtube.com/view_play_list?p=825EE416379D8F72&playnext=1

Report:
http://crash-stats.mozilla.com/report/index/a45e1748-39dc-4756-b7db-ba1f22101101

My Flash version is 10,1,85,3
Comment 6 Ted Mielczarek [:ted.mielczarek] 2010-11-01 07:28:40 PDT
Thanks, that's useful info. I don't know that crash reporting was tested with a 64-bit Firefox and a 32-bit plugin. I'll look into this.
Comment 7 d.a. 2010-11-01 07:38:43 PDT
FWIW I didn't get any crash reports with 64-bit Firefox and 64-bit plugin either while I was testing it.

I went back to the 32-bit plugin in part because the fullscreen didn't work (see bug 607023)
Comment 8 Ben Turner (not reading bugmail, use the needinfo flag!) 2010-11-01 07:57:58 PDT
Ted, that's my setup too (64-bit Firefox, 32-bit plugins).
Comment 9 juan becerra [:juanb] 2010-11-01 11:04:38 PDT
Marcia, I'll add the manual test here and in litmus later when we have a good set in the spreadsheet: https://spreadsheets.google.com/ccc?key=0Ar0rkj-NjT-WdEdUU1VFbk95YU5jV1JpeEFxMnNNaGc&authkey=CKrD6tUN&hl=en#gid=0

(anyone else is welcome to add tests there or comment)
Comment 10 Maniac Vlad Florin (:vladmaniac) 2010-11-02 02:09:44 PDT
Hy everyone, these are my proposals for Litmus tests 

https://spreadsheets.google.com/ccc?key=0AlsgObMBZ381dFo3cDlwNk5EaU5JLXdId0U5RXNaNXc&hl=en#gid=0

unfortunately it needs more investigating. 

I can't reproduce Marcia's problem since hulu.com videos are not available outside the US...
Comment 11 juan becerra [:juanb] 2010-11-04 15:50:47 PDT
We should try to fix this in one of the betas to get an idea of these types of crashes.

While they are not the same as a browser crash, they are disruptive to the user experience, and there might be things we can do to improve that, or contact the right people at Adobe to alert them before a lot more users see this.

It's not uncommon for me to experience this problem (I can't reproduce on command).
Comment 13 Ted Mielczarek [:ted.mielczarek] 2010-11-30 13:51:21 PST
Okay, so after doing some tests with the test plugin, it looks like we don't actually get crash reports at all from a 32-bit plugin running with a 64-bit browser.
Comment 14 chris hofmann 2010-11-30 15:05:34 PST
should this be moved up to beta9 ?   betaN means we not have time to get this working right in time to fix any problems that are hiding in missed crash reports.
Comment 15 Ted Mielczarek [:ted.mielczarek] 2010-12-06 11:47:08 PST
I'm about 50% through this. There are a large number of places in Breakpad where the OOP minidump generation code assumes it's dumping a process of the same CPU architecture, so fixing this involves refactoring a large amount of code.
Comment 16 Ted Mielczarek [:ted.mielczarek] 2010-12-08 13:33:35 PST
Patch is up for review upstream:
http://breakpad.appspot.com/241001/show
Comment 17 Ted Mielczarek [:ted.mielczarek] 2010-12-15 13:56:57 PST
Landed upstream:
http://code.google.com/p/google-breakpad/source/detail?r=746

Will land on m-c shortly.
Comment 18 Ted Mielczarek [:ted.mielczarek] 2010-12-16 14:25:22 PST
I tested this in the browser and it wasn't working, so I started writing more unit tests and found that I had missed a bit. That patch is up for review upstream:
http://breakpad.appspot.com/244001
Comment 19 Ted Mielczarek [:ted.mielczarek] 2010-12-16 14:53:33 PST
Landed upstream:
http://code.google.com/p/google-breakpad/source/detail?r=747
Comment 20 Ted Mielczarek [:ted.mielczarek] 2010-12-16 16:16:01 PST
Pushed to m-c:
http://hg.mozilla.org/mozilla-central/rev/2020888cd34f
Comment 21 Henrik Skupin (:whimboo) 2010-12-19 06:32:45 PST
Verified fixed based on my testcase on bug 619757.

Note You need to log in before you can comment on or make changes to this bug.